% Program demo_6_1
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Sampling rate conversion by L/M = 3/2
close all, clear all
Fx = 20;   Tx=1/Fx;                      % Original sampling frequency in Hz
tx = 0:Tx:1;                             % Time vector tx
x = 0.9*sin(2*pi*tx);                    % Input sequence
y = resample(x,3,2);                     % Re-sampling
ty = (0:(length(y)-1))*2*Tx/3;           % New time vector ty
figure (1)
subplot(2,1,1), stem(tx,x,'*k')
hold on
stem(ty,y,'-.k')
legend('original','resampled'),xlabel('Time'), ylabel('Amplitude'), axis([0,1,-1,1])
