% Program demo_6_4.m
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Generating linear fractional delay filters
clear all, close all
for k = 0:9
    mu = k/10;
    % h(k+1) = farrow.linearfd(mu);
    h(k+1)= dfilt.farrowlinearfd(mu); %farrow.linearfd(mu) is obsolete
end
[phi,f] = phasedelay(h,512,2); % Computing the phase delay
figure (1)
plot(f,phi/pi,'k','LineWidth',1)
xlabel('\omega/\pi'), ylabel('Phase delay (samples)'), grid
[H,f] = freqz(h,512,2);  % Computing the frequency response
figure (2)
plot(f,abs(H),'k','LineWidth',1)
xlabel('\omega/\pi'), ylabel('Magnitude'), axis([0,1,0,1.1]),grid
 
% Aplying the fractional delay filter
t=0:9;
x=0.5*sin(pi*0.2*t)+(sin(pi*0.1*t));  % Original sequence
y1=filter(h(3),x);                              % 0.2-sample delay
y2=filter(h(6),x);                              % 0.5-sample delay
figure (3)
stem(t,x,'k'); hold on; stem(t-0.2,y1,'kv--','filled')
hold on; stem(t-0.5,y2,'ks-.','filled')
xlabel('n'),ylabel('Amplitude')
legend('\mu=0','\mu=0.2','\mu=0.5'), grid

