% Program demo_6_5.m 
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Lagrange fractional-delay filters for N=1, N=3, N=5, and N=7.
clear all, close all
mu = 0.4; % Fractional delay
h1 = dfilt.farrowlinearfd(mu);
fd = fdesign.fracdelay(mu,'N',3);
h3 = design(fd,'lagrange','FilterStructure','farrowfd'); % updated
fd = fdesign.fracdelay(mu,'N',5);
h5 = design(fd,'lagrange','FilterStructure','farrowfd'); % updated
fd = fdesign.fracdelay(mu,'N',7);
h7 = design(fd,'lagrange','FilterStructure','farrowfd'); % updated
[phi1,f] = phasedelay(h1,512,2);
[phi3,f] = phasedelay(h3,512,2);
[phi5,f] = phasedelay(h5,512,2);
[phi7,f] = phasedelay(h7,512,2);
[H1,f] = freqz(h1,512,2);
[H3,f] = freqz(h3,512,2);
[H5,f] = freqz(h5,512,2);
[H7,f] = freqz(h7,512,2);
figure (1)
plot(f,phi1,'k',f,phi3,'k',f,phi5,'k',f,phi7,'k','LineWidth',1)
xlabel('\omega/\pi'), ylabel('Phase delay (samples)'), grid
figure (2)
plot(f,abs(H1),'k',f,abs(H3),'k',f,abs(H5),'k',f,abs(H7),'k','LineWidth',1)
xlabel('\omega/\pi'), ylabel('Magnitude'), grid, axis([0,1,0,1.1])

