% Program demo_6_6.m
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Fractional-delay filtering with the change of the delay
clear all, close all
t = 0:9;
x = sin(2*pi*0.1*t);
for i=1:10
    if i <= 5, mu(i)=0.4;
    else
        mu(i)=0.2;
    end
end
%h = farrow.linearfd(mu);
h = dfilt.farrowlinearfd(mu); % updated
h.PersistentMemory = true;
for i=1:10
    h.Fracdelay = mu(i);
    ty(i) = t(i)-mu(i);
    y(i) = filter(h,x(i));
end
figure (6)
stem(t,x,'k'); hold on; stem(ty,y,'ks--')
xlabel('n'),ylabel('Amplitude')
legend('Original Signal','Delayed Signal')
grid
