% Example 6_2
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
L=5; M=3;
F=[0,0.8,1];
m=[0,1,0];
x=fir2(256,F,m);
h=firgr(80,[0,1/6,1/5,1],[1,1,0,0]);
[H,ff]=freqz(h,1,512,2);
[X,ff]=freqz(x,1,512,2);
figure(1)
subplot(3,2,1)
plot(ff,abs(X)),ylabel('|X|')
axis([0,1,0,1.2])
subplot(3,2,3)
plot(ff,20*log10(abs(H))),ylabel('20log|H_1|')
axis([0,1,-60,5])
y=upfirdn(x,h,L,M);
[Y,f1]=freqz(y,1,1024,2);
subplot(3,2,5)
plot(f1,abs(Y)),ylabel('|Y_1|'), xlabel('\omega/\pi')
axis([0,1,0,0.4])
%new filter
h=firgr(140,[0,1/6,1/5,1],[1,1,0,0]);
[H,ff]=freqz(h,1,512,2);
subplot(3,2,2)
plot(ff,abs(X)),ylabel('|X|')
axis([0,1,0,1.2])
subplot(3,2,4)
plot(ff,20*log10(abs(H))), ylabel('20log|H_2|')
axis([0,1,-60,5])
y=upfirdn(x,h,L,M);
[Y,f1]=freqz(y,1,1024,2);
subplot(3,2,6)
plot(f1,abs(Y)),ylabel('|Y_2|'), xlabel('\omega/\pi')
axis([0,1,0,0.4])