% Example_6_4
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
close all
L=147;, M=160;
rp = 0.2;
rs = 50; 
f = [1/250,1/160]; 
a = [1 0];
dev = [(10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
[n,fo,ao,w] = firpmord(f,a,dev,2);
length(n)
h = firpm(n,fo,ao,w);
%hm = mfilt.firsrc(L,M,147*h); % mfilt.firsrc is obsolete.  
firrc = dsp.FIRRateConverter(L,M,L*h); % dsp.FIRRateConverter is used instead of mfilt.firsrc.
n=0:2*M-1;
x=sin(2*pi*0.010*n)+0.5*sin(2*pi*0.025*n);
tx=(1/48000)*n;
[H,f]=freqz(h,1,10000,2);
figure (1)
subplot(2,1,1)
plot(f(1:1000),20*log10(abs(H(1:1000)))), xlabel('\omega/\pi'), ylabel('Gain, dB')
axis([0,0.1,-60,5])
subplot(4,2,6)
plot(f(1:41),20*log10(abs(H(1:41))))
figure (2)
subplot(2,1,1)
stem(tx(1:100)*1000,x(1:100)),xlabel('t [ms]'), ylabel('Amplitude')
axis([0,2,-2,2])
y = step(firrc,x');
ty=tx*M/L;
subplot(2,1,2)
stem(ty(1:100)*1000,y(1:100)),xlabel('t [ms]'), ylabel('Amplitude')
axis([0,2,-2,2])